local building = {
	[0] = MT_SENTRY,
	[1] = MT_SENTRY,
	[2] = MT_DISPENSER,
	[3] = MT_TP_START,
	[4] = MT_TP_END,
	[5] = MT_THOK,
	[6] = MT_THOK
}

local buildtonum = {
	[MT_SENTRY] = 1,
	[MT_DISPENSER] = 2,
	[MT_TP_START] = 3,
	[MT_TP_END] = 4,
	[MT_THOK] = 0
}

local buildcost = {
	[MT_SENTRY] = 10,
	[MT_DISPENSER] = 25,
	[MT_TP_START] = 5,
	[MT_TP_END] = 5,
	[MT_THOK] = 0
}

local numcost = {
	[0] = 0,
	[1] = 10,
	[2] = 25,
	[3] = 5,
	[4] = 5,
	[5] = 0,
	[6] = 0
}

local function TF2_GetTheToolbox(player)
							player.box = true
							player.carry = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BUILD_BOX)
							if player.carry
								player.builds[player.buildbox] = player.carry
								player.carry.lebuild = building[player.buildbox]
								player.carry.carried = true
								player.carry.state = S_BUILD_BOX
								player.carry.tracer = player.mo
								player.carry.target = player.mo
								player.carry.color = player.mo.color
								player.carry.flags = MF_SCENERY|MF_NOGRAVITY
								player.carry.angle = player.drawangle - ANGLE_180
								player.carry.scale = FRACUNIT/4*3
								player.carry.numbahsevenwithextradip = player.buildbox
								if displayplayer == player
									if R_PointToDist(player.carry.x, player.carry.y) <= 15*FRACUNIT
										player.carry.frame = $|FF_TRANS70
									else
										player.carry.frame = $ & ~FF_TRANS70
									end
								end
							end	
end

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and not player.spectator and player.mo.skin == "engitails"
		if leveltime == 2
			for i = 1, 4
				if player.builds[i] and player.builds[i].valid
					P_KillMobj(player.builds[i])
				end
				player.builds[i] = nil
			end	
		end
		if not player.builds
			player.builds = {}
		end	
		player.buildpda = $ or 0
		player.buildbox = $ or 0
		if player.buildbox > 5
			player.buildbox = 1
		end
		if player.buildpda
			player.buildpda = $ - 1
			player.chose = true
		else
			if player.chose
				player.chose = false
				if not player.builds[player.buildbox]
				and player.rings >= buildcost[building[player.buildbox]]
					if player.buildbox != 5
					and player.buildbox != 6
						if ((player.buildbox == 3
						or player.buildbox == 4)
						and player.pflags & PF_FINISHED)
							TF2_GetTheToolbox(player)
						end
						if player.buildbox != 3
						and player.buildbox != 4
							TF2_GetTheToolbox(player)
						end
					end	
				end	
				player.buildbox = 0
			end
		end
		if player.cmd.buttons & BT_CUSTOM2
			if not player.c2
			and not player.box
				player.buildpda = TICRATE
				player.buildbox = $ + 1
			end
		end
		if player.buildpda
		or player.box
		or (player.dashcd and player.dashcd < 20)
			player.charability2 = CA2_NONE
		else
			player.charability2 = CA2_SPINDASH
		end
		if player.box and player.carry and player.carry.valid
			local addx = player.mo.x + FixedMul(30*FRACUNIT, cos(player.drawangle)) 
			local addy = player.mo.y + FixedMul(30*FRACUNIT, sin(player.drawangle)) 
			P_TeleportMove(player.carry, addx, addy, player.mo.z + (player.mo.height/3))
			player.carry.momx = player.mo.momx
			player.carry.momy = player.mo.momy
			player.carry.momz = player.mo.momz
			//P_TryMove(player.carry, addx, addy)
			player.carry.angle = player.drawangle - ANGLE_180
			if player.rings < numcost[player.carry.numbahsevenwithextradip]
				player.box = false
				for i = 1, 4
					if player.builds[i] and player.builds[i].valid
						if player.carry == player.builds[i]
							player.builds[i] = nil
						end	
					end	
				end
				player.carry.flags2 = $|MF2_DONTDRAW
				player.carry.flags = MF_SCENERY|MF_NOTHINK	
				player.carry = nil
			end
			if player.cmd.buttons & BT_SPIN
			and not player.spin
				P_TeleportMove(player.carry, player.mo.x, player.mo.y, player.mo.z + (player.mo.height/3))
				player.box = false
				player.carry.carried = false
				player.carry.angle = player.drawangle - ANGLE_180
				player.carry.flags = MF_SCENERY
				player.carry.build = 1
				player.carry.stopmom = true
				player.rings = $ - numcost[player.carry.numbahsevenwithextradip]
				P_SetObjectMomZ(player.carry, 5*FRACUNIT)
				P_InstaThrust(player.carry, player.drawangle, 5*FRACUNIT + player.speed)
			end
			if player.cmd.buttons & BT_CUSTOM2
			and not player.c2
				player.box = false
				for i = 1, 4
					if player.builds[i] and player.builds[i].valid
						if player.carry == player.builds[i]
							player.builds[i] = nil
						end	
					end	
				end
				local ghote = P_SpawnGhostMobj(player.carry)
				ghote.destscale = FRACUNIT*2
				ghote.fuse = 15
				ghote.colorized = true
				player.carry.flags2 = $|MF2_DONTDRAW
				player.carry.flags = MF_SCENERY|MF_NOTHINK	
				player.carry = nil
			end
		end
		player.dashcd = $ or 0
		player.dashangle = $ or player.drawangle
		if player.dashcd
			player.dashcd = $ - 1
			if player.dashcd >= 15
				player.mo.momz = 0
				if player.dashangle
				and player.moved
					player.drawangle = player.dashangle
					P_InstaThrust(player.mo, player.dashangle, FixedMul(cos(((player.dashcd)*ANG1*5) - ANGLE_135),FRACUNIT*60))
				end	
				if not player.moved
					player.mo.flags2 = $|MF2_DONTDRAW
					local addx1 = player.mo.x + FixedMul(P_RandomRange(25, 30)*FRACUNIT, cos(player.drawangle+ANGLE_90+P_RandomRange(-15,15)*ANG1))
					local addy1 = player.mo.y + FixedMul(P_RandomRange(25, 30)*FRACUNIT, sin(player.drawangle+ANGLE_90+P_RandomRange(-15,15)*ANG1))
					local addx2 = player.mo.x + FixedMul(P_RandomRange(25, 30)*FRACUNIT, cos(player.drawangle-ANGLE_90+P_RandomRange(-15,15)*ANG1))
					local addy2 = player.mo.y + FixedMul(P_RandomRange(25, 30)*FRACUNIT, sin(player.drawangle-ANGLE_90+P_RandomRange(-15,15)*ANG1))
					for i = 1, 6
						local ghost1 = P_SpawnGhostMobj(player.mo)
						ghost1.fuse = 2
						ghost1.tracer.fuse = 2
						//ghost1.tracer.state = S_TAILSOVERLAY_RUN
						P_TeleportMove(ghost1, addx1, addy1, player.mo.z)
						P_TeleportMove(ghost1.tracer, addx1, addy1, player.mo.z)
						local ghost2 = P_SpawnGhostMobj(player.mo)
						ghost2.fuse = 2
						ghost2.tracer.fuse = 2
						//ghost2.tracer.state = S_TAILSOVERLAY_RUN
						P_TeleportMove(ghost2, addx2, addy2, player.mo.z)
						P_TeleportMove(ghost2.tracer, addx2, addy2, player.mo.z)
						if not P_IsObjectOnGround(player.mo)
							ghost1.tracer.state = S_TAILSOVERLAY_RUN
							ghost2.tracer.state = S_TAILSOVERLAY_RUN
						end
					end
					player.powers[pw_flashing] = 2
				end	
				if player.dashcd == 15
					//player.mo.state = S_PLAY_SKID
					player.charability2 = CA2_SPINDASH
					if player.moved
						local ghost = P_SpawnGhostMobj(player.followmobj)
						ghost.destscale = FRACUNIT/2
						ghost.fuse = 15
						ghost.colorized = true
						ghost.color = SKINCOLOR_RED
					end	
					player.mo.spriteyscale = FRACUNIT
					player.mo.spritexscale = FRACUNIT
					player.mo.flags2 = $ & ~MF2_DONTDRAW
				else
					player.prespednd = player.speed
					player.charability2 = CA2_NONE
					if player.moved
						player.mo.state = S_PLAY_RUN
						local ghost = P_SpawnGhostMobj(player.followmobj)
						ghost.destscale = FRACUNIT*2
						ghost.fuse = 6
						ghost.colorized = true
					end	
					if player.dashcd >= 15 //Whats 9 + 10? 21. U stupid.
					and player.moved
						player.powers[pw_flashing] = 2
					end
				end
			end
		end
		if P_IsObjectOnGround(player.mo)
			player.times = 2
		end
		if player.cmd.buttons & BT_CUSTOM1
			if not player.c1
			and not player.dashcd
			and player.times
				player.dashcd = 25
				player.dashangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
				if (player.cmd.forwardmove or player.cmd.sidemove)
					player.moved = true
					S_StartSound(player.mo, sfx_spdpad)
				else
					player.moved = false
					S_StartSound(player.mo, sfx_intp)
				end	
				player.times = $ - 1
				player.pflags = $ & ~(PF_SPINNING|PF_STARTDASH)
				player.engifly = false
				if not P_IsObjectOnGround(player.mo)
					player.pflags = $|PF_THOKKED|PF_JUMPED
					player.pflags = $ & ~PF_CANCARRY
				end	
			end
			player.c1 = true
		else
			player.c1 = false
		end
		if player.engifly
			player.pflags = $|PF_CANCARRY
			if (player.cmd.buttons & BT_SPIN)
			and not player.spin
				player.engifly = false
				player.pflags = $|PF_THOKKED|PF_JUMPED
				player.pflags = $ & ~PF_NOJUMPDAMAGE
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_spin)
				player.pflags = $ & ~PF_CANCARRY
			end
			if player.boosttime
				player.boosttime = $ - 1
				if player.cmd.buttons & BT_JUMP
					P_SetObjectMomZ(player.mo, FRACUNIT/4*3, true)
				end
			end
			if player.mo.state == S_PLAY_FLY
				if player.mo.momz*P_MobjFlip(player.mo) < -5*FRACUNIT
					P_SetObjectMomZ(player.mo, -5*FRACUNIT)
				end
				if not S_SoundPlaying(player.mo, sfx_putput)
					S_StartSound(player.mo, sfx_putput)
				end
			end	
			if P_IsObjectOnGround(player.mo)
				player.engifly = false
			end
		else
			if S_SoundPlaying(player.mo, sfx_putput)
				S_StopSoundByID(player.mo, sfx_putput)
			end
		end
		if player.cmd.buttons & BT_SPIN
			player.spin = true
		else
			player.spin = false
		end
		if player.cmd.buttons & BT_CUSTOM2
			player.c2 = true
		else
			player.c2 = false
		end
		//local builds = player.builds
		//print(#builds)
	end
end)

addHook("AbilitySpecial", function(player)
	if player.valid and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "engitails"
		if not (player.pflags & PF_THOKKED)
		and not player.dashcd
			player.pflags = $|PF_JUMPED|PF_THOKKED|PF_NOJUMPDAMAGE
			player.mo.state = S_PLAY_FLY
			P_SetObjectMomZ(player.mo, 5*FRACUNIT)
			/*if not (player.cmd.forwardmove <= -25)
				P_InstaThrust(player.mo, player.mo.angle, 10*FRACUNIT)
			end	*/
			player.mo.momx = $/3
			player.mo.momy = $/3
			S_StartSound(player.mo, sfx_wdjump)
			player.drawangle = player.mo.angle
			player.engifly = true
			player.boosttime = 20
			//player.pflags = $|PF_CANCARRY
			TF2_DoubleJumpEffect(player.mo)
		end
	end
end)

addHook("MobjDamage", function(mobj, mo)
	if mobj and mobj.valid 
	and (mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS or mobj.flags & MF_MONITOR)
		if mo and mo.valid and mo.type == MT_PLAYER
		and mo.player
			if mo.player.pflags & PF_SPINNING
				if mo.player.powers[pw_flashing]
					mo.dontdisturb = mo.player.powers[pw_flashing]
				end
				P_DoPlayerPain(mo.player, mobj, mobj)
				if not mo.dontdisturb
					mo.player.powers[pw_flashing] = 2
				else
					mo.player.powers[pw_flashing] = mo.dontdisturb
				end
				mo.dontdisturb = 0
			end
			if mo.player.dashcd and mo.player.dashcd >= 15
				mo.player.dashcd = 20
				mo.player.charability2 = CA2_SPINDASH
			end
		end
	end
end)

local MARK_SENTRY = 1
local MARK_DISPENS = 2
local MARK_TELEPT = 3

addHook("PlayerMsg", function(player, msgtype, target, msg)
	if not msgtype
	if not (string.find(string.lower(msg), "here")
	or string.find(string.lower(msg), "there")
	or string.find(string.lower(msg), "'ere")) then return end
	if string.find(string.lower(msg), "sentry")
		local mark1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 5, MT_MARKER)
		mark1.marker = MARK_SENTRY
		mark1.fuse = 150
		mark1.state = S_MARK_ARROW
		mark1.color = player.mo.color
		mark1.tracer = player.mo
	elseif string.find(string.lower(msg), "dispenser")
		local mark2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 5, MT_MARKER)
		mark2.marker = MARK_DISPENS
		mark2.fuse = 150
		mark2.state = S_MARK_ARROW
		mark2.color = player.mo.color
		mark2.tracer = player.mo
	elseif (string.find(string.lower(msg), "teleporter")
	or string.find(string.lower(msg), "tele")
	or string.find(string.lower(msg), "tp"))
		local mark3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 5, MT_MARKER)
		mark3.marker = MARK_TELEPT
		mark3.fuse = 150
		mark3.state = S_MARK_ARROW
		mark3.color = player.mo.color
		mark3.tracer = player.mo
	end
	end
end)

hud.add(function(v, player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
		local ychose = {
		[1] = 155*FRACUNIT,
		[2] = 135*FRACUNIT,
		[3] = 115*FRACUNIT,
		[4] = 115*FRACUNIT}
		local lifechose = {
		[1] = "SENLIFE",
		[2] = "DISLIFE",
		[3] = "TPLIN",
		[4] = "TPEX"}
		if player.builds
			for i = 1, 4
				if player.builds[i] and player.builds[i].valid
					v.drawScaled(16*FRACUNIT, ychose[i], FRACUNIT/2, v.cachePatch(lifechose[i]), V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap("sonic", player.mo.color))
					if i >= 3
						v.drawScaled(16*FRACUNIT, ychose[3], FRACUNIT/2, v.cachePatch("TPLIFE"), V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap("sonic", player.mo.color))
					end
					if player.builds[i].death
						if i == 2
							local timedis = G_TicsToMinutes(player.builds[i].death)..":"..G_TicsToSeconds(player.builds[i].death)%60
							if G_TicsToSeconds(player.builds[i].death)%60 < 10
								timedis = G_TicsToMinutes(player.builds[i].death)..":0"..G_TicsToSeconds(player.builds[i].death)%60
							else
								timedis = G_TicsToMinutes(player.builds[i].death)..":"..G_TicsToSeconds(player.builds[i].death)%60
							end
							v.drawString(40, ychose[i]/FRACUNIT + 3, timedis, V_SNAPTOBOTTOM|V_SNAPTOLEFT, "left")
							if player.builds[i].storedrings
								v.drawString(75, ychose[i]/FRACUNIT + 3, player.builds[i].storedrings, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_YELLOWMAP, "left")
							else
								v.drawString(75, ychose[i]/FRACUNIT + 3, 0, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_YELLOWMAP, "left")
							end
						else
							v.drawString(40, ychose[i]/FRACUNIT + 3, player.builds[i].death/TICRATE, V_SNAPTOBOTTOM|V_SNAPTOLEFT, "left")
						end
					else
						if i < 3
							if i == 2
								v.drawString(40, ychose[i]/FRACUNIT + 3, "0:00", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "left")
							else
								v.drawString(40, ychose[i]/FRACUNIT + 3, 0, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "left")
							end	
						end
					end
				end
			end
		end
		if player.buildpda
			v.draw(0, 0, v.cachePatch("NPDAMENU"), V_30TRANS|V_SNAPTOBOTTOM, v.getColormap("sonic", player.mo.color))
			local xchose = {
			[0] = 97,
			[1] = 97,
			[2] = 144,
			[3] = 191,
			[4] = 191,
			[5] = 238,
			[6] = 238,}
			if player.buildbox
				if player.buildbox <= 3
					v.draw(xchose[player.buildbox], 100, v.cachePatch("NPDAYARE"), V_SNAPTOBOTTOM, v.getColormap("sonic", player.mo.color))
				else
					v.draw(xchose[player.buildbox], 100, v.cachePatch("NPDAYAREALT"), V_SNAPTOBOTTOM, v.getColormap("sonic", player.mo.color))
				end
				if player.buildbox != 4
					v.draw(0, 0, v.cachePatch("NPDATPE"), V_SNAPTOBOTTOM, v.getColormap("sonic", player.mo.color))
				else
					v.draw(0, 0, v.cachePatch("NPDATPX"), V_SNAPTOBOTTOM, v.getColormap("sonic", player.mo.color))
				end	
			end
			v.draw(0, 0, v.cachePatch("NPDACHOSE"), V_SNAPTOBOTTOM, v.getColormap("sonic", player.mo.color))
			v.draw(0, 0, v.cachePatch("NPDATEXT"), V_SNAPTOBOTTOM, v.getColormap("sonic", player.mo.color))
			for i = 1, 4
				if player.builds[i] and player.builds[i].valid
					if i != 3 and i != 4
						v.draw(xchose[i], 100, v.cachePatch("NPDANOPE"), V_SNAPTOBOTTOM)
					end	
				end
			end
			if player.builds[4] and player.builds[4].valid
			and player.buildbox and player.buildbox == 4
				v.draw(xchose[4], 100, v.cachePatch("NPDANOPE"), V_SNAPTOBOTTOM)
			end
			if player.builds[3] and player.builds[3].valid
			and player.buildbox and player.buildbox != 4
				v.draw(xchose[3], 100, v.cachePatch("NPDANOPE"), V_SNAPTOBOTTOM)
			end
			for i = 1, 4
				if player.rings < buildcost[building[i]]
					if i != 3
					and i != 4
						v.draw(xchose[i], 100, v.cachePatch("NPDANOPE"), V_SNAPTOBOTTOM)
					end	
				end
			end
			if player.rings < 5
				if player.buildbox
					if player.buildbox == 4
						v.draw(xchose[4], 100, v.cachePatch("NPDANOPE"), V_SNAPTOBOTTOM)
					else	
						v.draw(xchose[3], 100, v.cachePatch("NPDANOPE"), V_SNAPTOBOTTOM)
					end	
				end	
			end
			if not (player.pflags & PF_FINISHED)
				if multiplayer
					v.draw(xchose[4], 100, v.cachePatch("NPDAFINISHFIRST"), V_SNAPTOBOTTOM)
				else
					v.draw(xchose[4], 100, v.cachePatch("NPDANOPE"), V_SNAPTOBOTTOM)
				end	
			end
			if G_TicsToSeconds(player.buildpda)
				v.drawString(64, 116, G_TicsToSeconds(player.buildpda), V_SNAPTOBOTTOM, "thin-center")
			else
				v.drawString(64, 116, "0."..player.buildpda, V_SNAPTOBOTTOM, "thin-center")
			end	
			for i = 1, 4
				local red = V_SNAPTOBOTTOM
				if player.rings < buildcost[building[i]]
					red = V_SNAPTOBOTTOM|V_REDMAP
				else
					red = V_SNAPTOBOTTOM
				end
				v.drawString(xchose[i], 108, buildcost[building[i]], red, "left")
			end
		end
	end
end)