freeslot("MT_EFFECT")

mobjinfo[MT_EFFECT] = {
	doomednum = -1,
	spawnstate = S_THOK,
	spawnhealth = 1,
	speed = FRACUNIT*60,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT
}


rawset(_G, "SphereToCartesian", function(alpha, beta)
    local t = {}

    t.x = FixedMul(cos(alpha), cos(beta))
    t.y = FixedMul(sin(alpha), cos(beta))
	t.z = FixedMul(sin(FRACUNIT), sin(beta)) -- for elliptical orbit

    return t
end)

rawset(_G, "TF2_DoubleJumpEffect", function(mo)
	local beeg = P_SpawnMobjFromMobj(mo, 0, 0, -5*FRACUNIT, MT_GHOST)
	beeg.target = mo
	beeg.tracer = mo
	beeg.frame = $|FF_TRANS30
	beeg.state = S_SPINDUST1
	beeg.scale = FRACUNIT*2
	beeg.fuse = 15
	local exp = P_SpawnMobjFromMobj(mo, 0, 0, -5*FRACUNIT, MT_EXPLODE)
	exp.target = mo
	exp.tracer = mo
	local follow = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
	follow.target = mo
	follow.tracer = mo
	follow.state = S_PARTICLE
	follow.tics = TICRATE
	follow.flags2 = $|MF2_DONTDRAW
	follow.fuse = TICRATE
	follow.parentwtf = true
	follow.scale = 1
	follow.followathing = true
	follow.scalerot = -ANGLE_90
	for i = 1, 6
		local ranangle = P_RandomRange(1, 360)*ANG1
		local dist = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
		dist.destscale = -1
		dist.scalespeed = FRACUNIT/50
		dist.state = S_PARTICLE
		dist.tics = 15
		dist.flags2 = $|MF2_DONTDRAW
		dist.parentwtf = true
		P_InstaThrust(dist, ranangle, P_RandomRange(1, 10)*FRACUNIT)
		P_SetObjectMomZ(dist, P_RandomRange(0, 5)*FRACUNIT)
	end
end)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.parentwtf
			local trail = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_PARTICLE)
			trail.scale = mo.scale
			trail.frame = $|FF_TRANS30
			trail.state = mo.state
			if not mo.followathing
				trail.destscale = -1
				trail.scalespeed = FRACUNIT/16
			else
				trail.fuse = TICRATE
				trail.fusescale = true
			end	
		end
		if mo.fusescale
			if mo.fuse
				if mo.fuse <= 15
					mo.scale = $ - FRACUNIT/12
				end
			end
		end
		if mo.followathing
			if mo.scalerot
				mo.scalerot = $ + 5*ANG1
				mo.scale = FixedMul(FRACUNIT, cos(mo.scalerot))
			end
			A_CapeChase(mo,1,0)
		end
	end
end)